#!/usr/bin/python
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2011 <Davide Vescovini> <davide.vescovini@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

################################################################################
############# IMPORTAZIONE MODULI ##############################################
################################################################################
import sys
import os
import pygtk
pygtk.require('2.0')
import gtk, gobject
################################################################################
############# INTERNAZIONALIZZAZIONE ###########################################
################################################################################
import gettext
from gettext import gettext as _
gettext.textdomain('metel')
################################################################################
########### VARIABILI DA INIZIALIZZARE #########################################
################################################################################
# Add project root directory (enable symlink, and trunk execution).
PROJECT_ROOT_DIRECTORY = os.path.abspath(
    os.path.dirname(os.path.dirname(os.path.realpath(sys.argv[0]))))

if (os.path.exists(os.path.join(PROJECT_ROOT_DIRECTORY, 'preventares'))
    and PROJECT_ROOT_DIRECTORY not in sys.path):
    sys.path.insert(0, PROJECT_ROOT_DIRECTORY)
    os.putenv('PYTHONPATH', PROJECT_ROOT_DIRECTORY) # for subprocesses
################################################################################
############# IMPORTAZIONE MODULI  #############################################
################################################################################
from preventares.helpers import get_builder
from preventares.preventaresconfig import get_config_path
from preventares import metel_lib
from preventares import AddmetelDialog
from preventares.FileChooserDialog import FileChooserDialog
################################################################################
############ IMPOSTAZIONI LOGGINGS  ############################################
################################################################################
import logging
LOGGING = "PreventaLib"
logging.getLogger(LOGGING)
################################################################################
############ INTERFACCIA GRAFICA PER VISUALIZZAZIONE DATABASE METEL ############
################################################################################
class MetelWindow(gtk.Window):
    __gtype_name__ = "MetelWindow"
    
    # To construct a new instance of this method, the following notable 
    # methods are called in this order:
    # __new__(cls)
    # __init__(self)
    # finish_initializing(self, builder)
    # __init__(self)
    #
    # For this reason, it's recommended you leave __init__ empty and put
    # your inialization code in finish_intializing
    
    def __new__(cls, type = None, filename=None):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated MetelWindow object.
        """
        builder = get_builder('MetelWindow')
        new_object = builder.get_object("metel_window")
        new_object.finish_initializing(builder, filename)
        return new_object
    
    def __init__(self, filename=None):
        """""" 
        self.filename = filename

    def finish_initializing(self, builder, filename):
        """Called while initializing this instance in __new__

        finish_initalizing should be called after parsing the UI definition
        and creating a MetelWindow object with it in order to finish
        initializing the start of the new MetelWindow instance.
        
        Put your initilization code in here and leave __init__ undefined.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.builder.connect_signals(self)
        self.filename = filename
        #############################################################
        # Code for other initialization actions should be added here.
        #############################################################
        # Inizializzazione della libreria METEL
        self.metel = metel_lib.MetelClass(filename=self.filename)
        #imposta la variabile su nessun listino attivato (cioè visualizza tutti i listini)
        self.listino_attivato = None
        #imposta la variabile su nessuna riga copiata
        self.rigo_copiato = None
        #############################
        # supporto per il Drag&Drop
        self.treeview1 = builder.get_object("treeview1")
        self.TIPO_ART_LISTINO = 112
        self.ARTICOLI_LISTINO = "preventa/listino"
        self.DragFromListino = [(self.ARTICOLI_LISTINO, 0, self.TIPO_ART_LISTINO)]
        self.treeview1.connect("drag_data_get", self.treeview1_drag_data_get)
        self.treeview1.drag_source_set(gtk.gdk.BUTTON1_MASK, self.DragFromListino, gtk.gdk.ACTION_COPY)
        #############################
        # Treeview Listino
        #############################
        # create a liststore with one string column to use as the model
        self.liststore = gtk.ListStore(str, str, str, str, str, str, str)
        self.treeview1.set_model(self.liststore)
        self.treeview1.connect("button-press-event", self.on_treeview1_button_press_event)
        # create the TreeViewColumns to display the data
        self.treeview1.columns = [None]*7
        self.treeview1.columns[0] = gtk.TreeViewColumn(_('Marchio'))
        self.treeview1.columns[1] = gtk.TreeViewColumn(_('Codice'))
        self.treeview1.columns[2] = gtk.TreeViewColumn(_('Descrizione'))
        self.treeview1.columns[3] = gtk.TreeViewColumn(_('Valuta'))
        self.treeview1.columns[4] = gtk.TreeViewColumn(_('u.m.'))
        self.treeview1.columns[5] = gtk.TreeViewColumn(_('Prezzo'))
        self.treeview1.columns[6] = gtk.TreeViewColumn(_('Data'))
        for n in range(7):
            # add columns to treeview
            self.treeview1.append_column(self.treeview1.columns[n])
            # create a CellRenderers to render the data
            self.treeview1.columns[n].cell = gtk.CellRendererText()
            # set the cells as editable
            #self.treeview1.columns[n].cell.set_property('editable', True)
            #self.treeview1.columns[n].cell.connect('edited', self.cell_edited, n) 
            # add the cells to the columns
            self.treeview1.columns[n].pack_start(self.treeview1.columns[n].cell, True)
            # set the cell attributes to the appropriate liststore column
            self.treeview1.columns[n].set_attributes(self.treeview1.columns[n].cell, text=n)
            # make treeview searchable
            self.treeview1.set_search_column(n)
            # Allow sorting on the column
            self.treeview1.columns[n].set_sort_column_id(n)
            # set column resizable
            self.treeview1.columns[n].set_resizable(True)
        #############################
        # Treeview Selezione Marche
        #############################
        # create a treestore with one string column to use as the model
        self.treestore = gtk.TreeStore(str)
        # create the TreeView using treestore
        self.treeview = builder.get_object("treeview2")
        self.treeview.set_model(self.treestore)
        # create a CellRenderer to render the data
        self.cell = gtk.CellRendererText()
        # create the TreeViewColumns to display the data
        self.tvcolumn = gtk.TreeViewColumn('Marche', self.cell)
        self.tvcolumn.add_attribute(self.cell, 'text', 0)
        # add columns to treeview
        self.treeview.append_column(self.tvcolumn)
        self.treeview.set_expander_column(self.tvcolumn)
        # make treeview searchable
        self.treeview.set_search_column(0)
        # Allow sorting on the column
        self.tvcolumn.set_sort_column_id(0)
        #############################
        # create a treestore with one string column to use as the model
        self.liststore_marche = gtk.ListStore(str, str, float, str)
        # create the TreeView using treestore
        self.treeview_marche = builder.get_object("treeview3")
        self.treeview_marche.set_model(self.liststore_marche)
        self.treeview_marche.columns = [None]*4
        self.treeview_marche.columns[0] = gtk.TreeViewColumn('Marche')
        self.treeview_marche.columns[1] = gtk.TreeViewColumn('Nome Marche')
        self.treeview_marche.columns[2] = gtk.TreeViewColumn('Sconto Medio')
        self.treeview_marche.columns[3] = gtk.TreeViewColumn('Data')
        for n in range(4):
            # add columns to treeview
            self.treeview_marche.append_column(self.treeview_marche.columns[n])
            # create a CellRenderers to render the data
            self.treeview_marche.columns[n].cell = gtk.CellRendererText()
            # set the cells as editable
            self.treeview_marche.columns[n].cell.set_property('editable', True)
            self.treeview_marche.columns[n].cell.connect('edited', self.cell_marche_edited, n)
            # add the cells to the columns
            self.treeview_marche.columns[n].pack_start(self.treeview_marche.columns[n].cell, True)
            # set the cell attributes to the appropriate liststore column
            self.treeview_marche.columns[n].set_attributes(self.treeview_marche.columns[n].cell, text=n)
            # set column resizable
            self.treeview_marche.columns[n].set_resizable(True)
            # make treeview searchable
            self.treeview_marche.set_search_column(n)
            # Allow sorting on the column
            self.treeview_marche.columns[n].set_sort_column_id(n)
        ###########################################
        # imposta i box per la ricerca nella treeview
        ###########################################
        # combobox di selezione del campo di ricerca
        self.liststore_campo = gtk.ListStore(str)
        self.box_campo = builder.get_object("combobox1")
        cell = gtk.CellRendererText()
        self.box_campo.pack_start(cell, True)
        self.box_campo.add_attribute(cell, 'text', 0)
        self.box_campo.set_model(self.liststore_campo)
        lista_campi = ["Descrizione", "Codice", "Prezzo"]
        for campo in lista_campi:
            self.liststore_campo.append([campo])
        self.box_campo.set_active(0)
        self.box_campo.connect("changed", self.Ricerca_articolo)
        # combobox di selezione della colonna di ricerca
        self.liststore_colonne = gtk.ListStore(str)
        self.box_colonne = builder.get_object("combobox2")
        self.box_colonne.pack_start(cell, True)
        self.box_colonne.add_attribute(cell, 'text', 0)
        self.box_colonne.set_model(self.liststore_colonne)
        lista_colonne = ["Marchio", "Descrizione", "Prezzo", "Codice"]
        for campo in lista_colonne:
            self.liststore_colonne.append([campo])
        self.box_colonne.set_active(0)
        self.box_colonne.connect("changed", self.Ricerca_articolo)
        ###########################################
        # Aggiorna la treeview dei listini
        self.Aggiorna_finestra_listini()
        # Popola l'interfaccia grafica con i dati estratti dal database
        self.Aggiorna_finestra_dialogo(lista=[])
        # nascondi la barra d'avanzamento
        progressbar = self.builder.get_object("progressbar1")
        progressbar.hide()

################################################################################
######################### PROGRAMMAZIONE DEI MENU DEI PULSANTI #################
################################################################################
    def save(self, widget, data=None):
        """Signal handler for closing the MetelWindow."""
        self.metel.save_database()

    def quit(self, widget, data=None):
        """Signal handler for closing the MetelWindow."""
        self.metel.connection_shutdown()
        ###################################
        # clean up code
        ###################################
        self.liststore.clear()
        # variabili da finestra listini METEL
        del self.metel
        # chiudi la finestra
        self.destroy()

    def on_destroy(self, widget, data=None):
        """Called when the MetelWindow is closed."""
        # Clean up code for saving application state should be added here.
        gtk.main_quit()

################################################################################
######################### PROGRAMMAZIONE DEL MENU LISTINI ######################
################################################################################
    def Cancella_database(self, widget, data=None):
        """cancella i dati dal database"""
        if self.message(self, "avviso", _("Questa operazione cancellerà tutti gli articoli importati!")):
            self.metel.delete_metel_database()
            # Aggiorna l'interfaccia grafica con i dati estratti dal database
            self.Aggiorna_finestra_dialogo()
            return True
        else: 
            return False

    def Cancella_listino(self, widget, data=None):
        """solo un listino dal database"""
        # ottengo l'attuale selezione della vista dalla treeview listini
        treeview2 = self.builder.get_object("treeview2")
        selection2 = treeview2.get_selection()
        model2, iter = selection2.get_selected()
        try:
            listino = model2.get_value(iter, 0)
        except TypeError:
            # ottengo l'attuale selezione della vista dalla treeview codici
            treeview1 = self.builder.get_object("treeview1")
            selection1 = treeview1.get_selection()
            model1, iter = selection1.get_selected()
            try:
                listino = model1.get_value(iter, 0)
            except:
                return False
        if self.message(self, "avviso", _("Questa operazione cancellerà l'intero listino '%s'" % listino)):
            # richiamo la routine per la cancellazione del rigo dal database
            self.metel.delete_listino (listino)       
            # Aggiorna l'interfaccia grafica
            self.Aggiorna_finestra_dialogo(lista=[])
            self.Aggiorna_finestra_listini()
            return True
        else:
            return False

    def Cancella_rigo_database(self, widget, data=None):
        """cancella un rigo dal database"""
        treeview1 = self.builder.get_object("treeview1")
        # ottengo l'attuale selezione della vista
        selection = treeview1.get_selection()
        model, iter = selection.get_selected()
        #costruisco la chiave univoca del db selezionando i 3 campi sigla + codice + valuta
        primary_key = model.get_value(iter, 0) + model.get_value(iter, 1) + model.get_value(iter, 3)
        if self.message(self, "avviso", _("Questa operazione cancellerà la riga selezionata")):
            # richiamo la routine per la cancellazione del rigo dal database
            self.metel.delete_row (primary_key)
            # Aggiorna l'interfaccia grafica
            self.Aggiorna_finestra_dialogo(lista=[])
            self.Aggiorna_finestra_listini()
            return True
        else:
            return False

    def Copia_rigo(self, widget, data=None):
        """Funzione per copiare un rigo nella maschera"""
        # ottengo l'attuale selezione della vista
        selection = self.treeview1.get_selection()
        model, iter = selection.get_selected()
        #metto in memoria la chiave univoca del db selezionando i 3 campi sigla + codice + valuta
        # SiglaMarchio, CodiceProdAzienda, DescrizioneProdotto, CodiceValuta, UnitaMisura, PrezzoPubblico, DataUltimaVariazione
        sigla = model.get_value(iter, 0)
        codice = sigla + model.get_value(iter, 1) + model.get_value(iter, 3)
        descrizione = model.get_value(iter, 2)
        um = model.get_value(iter, 4)
        prezzo = model.get_value(iter, 5)
        sconto = self.metel.get_sconto_marca (sigla)
        self.rigo_copiato =  [codice, descrizione, um, float(prezzo), float(sconto)]
        return self.rigo_copiato

    def Aggiungi_rigo(self, widget, data=None):
        """Funzione per aggiungere un codice metel nel database"""
        # apro la finestra di dialogo Addmetel
        dialog = AddmetelDialog.AddmetelDialog()
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            # importa la stringa nel database
            articolo = str(dialog.art_metel)
            self.metel.import_line (articolo)
            logging.debug(_("Importazione nel database dell'articolo METEL: {0}").format(articolo))
            # aggiorna l'interfaccia grafica
            self.Aggiorna_finestra_dialogo(lista=[])
            self.Aggiorna_finestra_listini()
        else:
            pass
        dialog.destroy()
        return True

    def espandi_treeview_listini(self, widget, data=None):
        """Espande la treeview"""
        self.treeview.expand_all()

    def collassa_treeview_listini(self, widget, data=None):
        """Collassa la treeview"""
        self.treeview.collapse_all()

################################################################################
######################## FINESTRA ELENCO LISTINI CARICATI ######################
################################################################################
    def Lista_listini(self):
        """restituisce una lista dei marchi del database"""
        lista_marchi = self.metel.extract_marche_metel()
        lista_alfabetica = set()
        for marchio in lista_marchi:
            lettera = marchio[0:1]
            lista_alfabetica.add(lettera)
        return lista_marchi, lista_alfabetica

    def Aggiorna_finestra_listini(self):
        """Aggiorna la treeview dei listini"""
        lista_marchi, lista_alfabetica = self.Lista_listini()
        ##########################
        # Create the ProgressBar
        self.progressbar = ProgressBar(self.builder, testo = _("Caricamento listini Metel"), window_mode=False)
        ##########################
        # svuota l'attuale treestore
        self.treestore.clear()
        # popola la treeview
        self.treestore.append(None, ['-- Tutti --'])
        for lettera in sorted(lista_alfabetica):
            iter = self.treestore.append(None, [lettera])
            for marchio in lista_marchi:
                if marchio[0:1] == lettera:
                    self.treestore.append(iter, [marchio])
                    self.progressbar.avanza()
        ##########################
        # elimina la ProgressBar
        self.progressbar.destroy()
        ##########################
        self.Aggiorna_finestra_marche()

    def on_listino_activated(self, widget, lista=None, data=None):
        """Mostra soltanto il listino della marca richiesta, una volta selezionato"""
        # Se c'e` una riga selezionata nella treeview e la leggiamo
        selection = self.treeview.get_selection()
        model, iter = selection.get_selected()
        self.listino_attivato = model.get_value(iter, 0)
        # se non è stato attivato nessun listino visualizzali tutti
        if self.listino_attivato == '-- Tutti --' or self.listino_attivato == None:
           self.listino_attivato = None
           lista = None
        else:
           # Estrae righe database
           lista = self.metel.search_rows (listino=self.listino_attivato, list_columns=None)
        # Aggiorna la finestra di dialogo listini
        counter = self.Aggiorna_finestra_dialogo(lista=lista)
        self.BarraStato(self, _("%d articoli trovati") % counter)
        return counter

    def on_treeview1_button_press_event(self, widget, event, data=None):
        """Funzione per richiamare un menu popup alla pressione di un tasto del mouse"""
        treeview = self.builder.get_object("treeview1")
        # richiama il menu popup con il pulsante destro
        if event.button == 3:
            x = int(event.x)
            y = int(event.y)
            time = event.time
            pthinfo = treeview.get_path_at_pos(x, y)
            if pthinfo is not None:
                path, col, cellx, celly = pthinfo
                treeview.grab_focus()
                treeview.set_cursor( path, col, 0)
                # Crea e predispone un menu interattivo popup da utilizzare contestualmente
                self.popup_click_dx(self)
            else:
                # Crea e predispone un menu interattivo popup da utilizzare contestualmente
                self.popup_click_dx(self)
                for n in [0,1,4]:
                    self.popup.items[n].hide()
            # visualizza il menu popup
            self.popup.popup( None, None, None, event.button, time)
            return True
        elif event.button == 2:
            pass
            return True 
        else:
            return False

    def on_treeview2_button_press_event(self, widget, event, data=None):
        """Funzione per richiamare un menu popup alla pressione di un tasto del mouse"""
        treeview = self.builder.get_object("treeview2")
        # richiama il menu popup con il pulsante destro
        if event.button == 3:
            x = int(event.x)
            y = int(event.y)
            time = event.time
            pthinfo = treeview.get_path_at_pos(x, y)
            if pthinfo is not None:
                path, col, cellx, celly = pthinfo
                treeview.grab_focus()
                treeview.set_cursor( path, col, 0)
                # Crea e predispone un menu interattivo popup da utilizzare contestualmente
                self.popup = self.builder.get_object("menu3") # menu listini
                self.popup.popup( None, None, None, event.button, time)
            return True

    def treeview1_drag_data_get(self, widget, drag_context, selection_data, info, timestamp, data=None):
        """Copia in memoria il rigo trascinato nel Drag'n Drop per trasferirlo nel programma di computo"""
        if info == self.TIPO_ART_LISTINO:
            rigo_copiato = self.Copia_rigo(self)
        return True
################################################################################
######################## AGGIORNAMENTO FINESTRA ARTICOLI #######################
################################################################################
    def Aggiorna_finestra_dialogo(self, lista=None):
        """Estrae un rigo dal database per poter passare una lista a gtk.liststore"""
        # Cancella gli elementi dal liststore dell'interfaccia
        self.liststore.clear()
        # Estrae righe database
        if lista is None:
           lista = self.metel.search_rows(list_columns = None, order='SiglaMarchio')
        # Aggiorna la barra di stato
        nr_articoli = len(lista)
        self.BarraStato(self, _("{0} Articoli").format(nr_articoli))
        # Create the ProgressBar 
        self.progressbar = ProgressBar(self.builder, step = nr_articoli/1000, 
                                       window_mode=False, modal= False)
        # contatore righe mostrate nella maschera
        counter = 1
        for row in lista:
            # modifica il campo data in GG/MM/AAAA
            row = list(row)
            d = str(row[6])
            row[6] = "{0}/{1}/{2}".format(d[6:],d[4:6], d[:-4])
            # aggiunge gli articoli al liststore
            self.liststore.append(row)
            # aggiorna il contatore righe mostrate nella maschera
            counter += 1
            nr,rest = divmod(counter, 1000)
            if rest == 0:
                # aggiorna la barra d'avanzamento
                self.progressbar.avanza(testo = "{0:.0%}".format(float(nr*1000)/nr_articoli))
        # elimina la ProgressBar
        self.progressbar.destroy()
        return counter

################################################################################
######################## FINESTRA MARCHE #######################################
################################################################################

    def Aggiorna_finestra_marche(self):
        """Aggiorna la treeview delle marche con gli sconti"""
        # svuota l'attuale treestore
        self.liststore_marche.clear()
        for row in self.metel.extract_sconti_rows():
            self.liststore_marche.append(list(row))

    def cell_marche_edited(self, cell, path, new_text, col_nr):
        """modifica le righe della treeview"""
        model = self.treeview_marche.get_model()
        if col_nr == 2:
            try:
                model[path][col_nr] = float(new_text)
            except ValueError:
                model[path][col_nr] = 0.0
        else:
            model[path][col_nr] = new_text
        iter = model.get_iter(path)
        sigla, nome, sconto = model.get(iter, 0, 1, 2)
        self.metel.update_sconti_rows(sigla, nome, sconto)
        self.Aggiorna_finestra_marche()
################################################################################
######################## IMPORTAZIONE DI FILE METEL ############################
################################################################################

    def Importa_file_metel(self, widget, data=None):
        """importa un file metel nel database"""
        # Attiva una finestra per la scelta del file
        dialog = FileChooserDialog(filetype="txt")
        fileMetel = dialog.run()
        if fileMetel is not None:
            # Create the ProgressBar
            self.progressbar = ProgressBar(self.builder, testo = _("Importazione file %s" % fileMetel))
            while gtk.events_pending():
                gtk.main_iteration()
            # Importa il file
            self.metel.import_file (fileMetel)
            # Aggiorna la barra di stato
            self.BarraStato(self, _("File importato, %d articoli importati, %d articoli con errori (non importati)") % (self.metel.art_import, self.metel.err))
            # elimina la ProgressBar
            self.progressbar.destroy()
        else: 
            return 0
        # Aggiorna la treeview dei listini
        self.Aggiorna_finestra_listini()
        # Aggiorna la maschera principale
        self.Aggiorna_finestra_dialogo(lista=[])
        return self.metel.art_import

    def Importa_righe_metel(self, widget, data=None):
        """importa un file metel nel database"""
        # Attiva una finestra per la scelta del file
        dialog = FileChooserDialog(filetype="txt")
        fileMetel = dialog.run()
        if fileMetel is not None:
            lista = self.metel.read_metel_file(fileMetel)
            # Create the ProgressBar
            self.progressbar = ProgressBar(self.builder, step = len(lista), 
                                           testo = _("Caricamento file %s" % fileMetel))
            i=0
            for line in lista:
                i+=1
                row = self.metel.import_line (line)
                # aggiorna la barra d'avanzamento
                self.progressbar.avanza(i)
                while gtk.events_pending():
                    gtk.main_iteration()
            # salvataggio del database
            self.metel.save_database()
            # Aggiorna la barra di stato
            self.BarraStato(self, _("File importato, %d articoli importati, %d articoli con errori (non importati)") % (self.metel.art_import, self.metel.err))
            # elimina la ProgressBar
            self.progressbar.destroy()
        else: 
            return 0
        # Aggiorna la maschera principale
        self.Aggiorna_finestra_dialogo(lista=[])
        # Aggiorna la treeview dei listini
        self.Aggiorna_finestra_listini()
        return self.metel.art_import

    def Importa_cartella_metel(self, widget, data=None):
        """Importa nel database tutti i listini di una cartella"""
        lista_metel = list()
        dialog = FileChooserDialog(mode="folder")
        pathMetel = dialog.run()
        if pathMetel is not None:
            for file in os.listdir(pathMetel):
                root, ext = os.path.splitext(file)
                if ext == ".txt" or ext == ".TXT":
                    lista_metel.append(file)
            # Create the ProgressBar 
            self.progressbar = ProgressBar(self.builder, step = len(lista_metel), 
                                           testo = _("Importazione file METEL dalla cartella %s") % pathMetel)
            i=0
            for file in lista_metel:
                i+=1
                art = self.metel.import_file (os.path.join(pathMetel, file))
                # aggiorna la barra d'avanzamento
                self.progressbar.avanza(i)
                while gtk.events_pending():
                    gtk.main_iteration()
            # salvataggio del database
            self.metel.save_database()
            # Aggiorna la barra di stato
            self.BarraStato(self, _("Listini METEL importati dalla cartella %s") % pathMetel)
            # elimina la ProgressBar
            self.progressbar.destroy()
        else: 
            return 0
        # Aggiorna la maschera principale
        self.Aggiorna_finestra_dialogo(lista=[])
        # Aggiorna la treeview dei listini
        self.Aggiorna_finestra_listini()
        return self.metel.art_import

################################################################################
###  MENU POPUP CON CLICK DESTRO ###############################################
################################################################################
    def popup_click_dx(self, widget, data=None):
        """Menu popup a comparsa con click destro, può essere richiemato contestualmente con la sfunzione
        'self.popup.popup(parent_menu_shell, parent_menu_item, func, button, activate_time, data=None)' """
        self.popup = gtk.Menu()
        self.popup.items = [None]*5
        self.popup.items[0] = gtk.MenuItem(_("Copia Codice"))
        self.popup.items[1] = gtk.MenuItem(_("Cancella Codice"))
        self.popup.items[2] = gtk.MenuItem(_("Aggiungi Codice"))
        self.popup.items[3] = gtk.MenuItem(_("Carica Listino"))
        self.popup.items[4] = gtk.MenuItem(_("Cancella Listino"))
        MenuItem_callback = {0: self.Copia_rigo,
                             1: self.Cancella_rigo_database,
                             2: self.Aggiungi_rigo,
                             3: self.Importa_file_metel,
                             4: self.Cancella_listino}
        for n in range(5):
            self.popup.append(self.popup.items[n])
            self.popup.items[n].connect("activate", MenuItem_callback[n])
            self.popup.items[n].show()
        return self.popup

################################################################################
###  RICERCA DI UN ARTICOLO SPECIFICO ##########################################
################################################################################
    def get_active_text(self, widget, combobox, data=None):
        """La funzione permette di recuperare il testo selezionato da un combobox di scelta"""
        ComboBox = self.builder.get_object(combobox)
        model = ComboBox.get_model()
        active = ComboBox.get_active()
        if active < 0:
           return None
        return model[active][0]

    def Ricerca_articolo(self, widget, data=None):
        """La funzione permette di cercare un articolo nel database e filtrarlo nella maschera"""
        # ricava il testo selezionato dai combobox di scelta
        testo_combobox1 = self.get_active_text(self, "combobox1")
        testo_combobox2 = self.get_active_text(self, "combobox2")
        if testo_combobox1 == "Descrizione":
           column = "DescrizioneProdotto"
        elif testo_combobox1 == "Codice":
           column = "CodiceProdAzienda"
        elif testo_combobox1 == "Prezzo":
           column = "PrezzoPubblico"
        else:
           pass
        if testo_combobox2 == "Marchio":
           order = "SiglaMarchio"
        elif testo_combobox2 == "Descrizione":
           order = "DescrizioneProdotto"
        elif testo_combobox2 == "Prezzo":
           order = "PrezzoPubblico"
        elif testo_combobox2 == "Codice":
           order = "CodiceProdAzienda"
        else:
           pass
        testo_ricerca = self.builder.get_object("entry1").get_text()
        # Esegui un'istruzione sql di ricerca nel campo selezionato e crea una lista delle righe trovate
        lista_righe = self.metel.search_rows (listino=self.listino_attivato,
                      list_columns=None, search_column=column,
                      search_key=testo_ricerca, order=order)
        # Aggiorna la finestra di dialogo con la nuova lista
        articoli_trovati = self.Aggiorna_finestra_dialogo(lista=lista_righe)
        # Aggiorna la barra di stato
        self.BarraStato(self, _("%d articoli trovati") % articoli_trovati)
        return articoli_trovati

################################################################################
###  PARTE RELATIVA ALLA BARRA DI STATO ########################################
################################################################################
    def BarraStato(self, widget, testo):
        """Funzione per Aggiornare la Barra di Stato"""
        BarraStato = self.builder.get_object("statusbar1")
        contesto = BarraStato.push(0, testo)

################################################################################
###  PARTE RELATIVA ALLA FINESTRA MESSAGGI #####################################
################################################################################

    def message(self, widget, tipo, testo, data=None):
        """display a message windows"""
        buttons = gtk.BUTTONS_OK_CANCEL
        if tipo == "info":
           tipo = gtk.MESSAGE_INFO
           buttons = gtk.BUTTONS_CLOSE
        elif tipo == "avviso":
           tipo = gtk.MESSAGE_WARNING
        elif tipo == "domanda":
           tipo = gtk.MESSAGE_QUESTION
        elif tipo == "errore":
           tipo = gtk.MESSAGE_ERROR
           buttons = gtk.BUTTONS_CLOSE
        else:
           tipo == gtk.MESSAGE_INFO
           buttons = gtk.BUTTONS_CLOSE
        message = gtk.MessageDialog(parent=None, flags=0, type=tipo, buttons = buttons, message_format=testo)
        message.format_secondary_text(_("Premere un pulsante per continuare"))
        response = message.run()
        if response == gtk.RESPONSE_OK:
           response = True
        else:
           response = False 
        message.destroy()
        return response

################################################################################
###  PARTE RELATIVA ALLA BARRA DI AVANZAMENTO ##################################
################################################################################
class ProgressBar():
    def __init__(self, builder, testo=None, step=None, modal=True, window_mode=True):
        self.builder = builder
        self.window = None
        self.activity_mode = False
        self.timer = 0
        self.step = 0.1
        if not window_mode:
            # connetti e mostra l'oggetto barra d'avanzamento della finestra
            self.progressbar = self.builder.get_object("progressbar1")
            self.progressbar.show()
        elif window_mode: 
            # creazione della finestra della barra di avanzamento
            self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
            self.window.connect("destroy", self.destroy)
            self.window.set_title(_("Barra di avanzamento"))
            self.window.set_border_width(0)
            self.window.set_default_size(600, 100)
            self.window.set_position(gtk.WIN_POS_CENTER)
            self.window.set_resizable(False)
            self.window.set_modal(modal)
            # CREA UN BOX VERTICALE
            vbox = gtk.VBox(False, 4)
            vbox.set_border_width(5)
            self.window.add(vbox)
            vbox.show()
            # Create a centering alignment object
            align = gtk.Alignment(0.5, 0.5, 0, 0)
            align.set_padding(0, 0, 5, 5)
            vbox.pack_start(align, False, False, 5)
            align.show()
            # Create the ProgressBar
            self.progressbar = gtk.ProgressBar()
            align.add(self.progressbar)
            self.progressbar.show()
            # mostra la finestra
            self.window.show()
        # imposta il testo della progressbar
        if testo is None: 
           testo = str()
        self.progressbar.set_text(testo)
        # imposta la modalità frazione o 'attivita'
        if type(step) == int and step > 0:
            self.step = 0.1/(float(step)/10)
            self.progressbar.set_fraction(0.0)
        else:
            self.activity_mode = True
            # Add a timer callback to update the value of the progress bar
            self.progressbar.set_pulse_step(0.1)
            self.timer = gobject.timeout_add (100, progress_timeout, self)
        # cambia il cursore del mouse da normale a quello d'attesa
        self.cursor_wait = gtk.gdk.Cursor(gtk.gdk.WATCH)
        self.gdk_window = self.progressbar.get_parent_window()
        if self.gdk_window is not None:
            self.gdk_window.set_cursor(self.cursor_wait)

    def avanza(self, testo = None):
        """Avanza la barra di avanzamento"""
        if testo is not None:
            # imposta il testo della progressbar
            self.progressbar.set_text(str(testo))
        if not self.activity_mode:
            new_val = self.progressbar.get_fraction() + self.step
            # Set the new value
            if new_val <= 1.0:
                self.progressbar.set_fraction(new_val)
            else:
                self.progressbar.set_fraction(1.0)
        else:
            self.progressbar.pulse()
        while gtk.events_pending():
            gtk.main_iteration()
        # As this is a timeout function, return TRUE so that it
        # continues to get called
        return True

    def destroy(self, data=None):
        """distruggi la finestra della barra di avanzamento"""
        if self.window is not None:
            self.window.destroy()
        else: 
            self.progressbar.hide()
        if self.activity_mode:
            gobject.source_remove(self.timer)
        self.timer = 0
        # torna a impostare il cursore del mouse normale
        if self.gdk_window is not None:
            self.gdk_window.set_cursor(None)
        return True

# Update the value of the progress bar so that we get some movement
def progress_timeout(pbobj):
    pbobj.progressbar.pulse()
    while gtk.events_pending():
        gtk.main_iteration()
    return True
